#!/usr/dist/pkgs/perl,v5.003/5bin.sun4/perl

require 5.003;
BEGIN {
    my($workdir) = ($0 =~ /(.*)\/.*/);
    unshift(@INC, "$workdir/../lib");
}
my($workdir) = ($0 =~ /(.*)\/.*/);
use BER;
use SNMP_Session;
use SNMP_MIB;
use SNMP_Simple;
use Socket;
use strict;
#use Ping;

### MAIN ###

my($host) = "$ARGV[0]";
my(@hostip);
my($community) = "public";

SNMP_MIB::loadoids("$workdir/../mibs", "RFC1213");
@hostip = gethostbyname($host);
$hostip[0] = inet_aton($hostip[0]);
my ($aip,$bip,$cip,$dip) = unpack('C4',$hostip[0]);
#my $ping = Ping->new("udp");

for ($dip=1; $dip <= 254; $dip++) {
  $host = "$aip.$bip.$cip.$dip";

  my $ping = system("/usr/sbin/ping $host > /dev/null 2>&1");
#  if ($ping->ping($host)) {
  if ($ping == 0) {
    my $session = SNMP_Simple->open ($host, $community, 161);
    $session->{'retries'} = 1;
    my @atifent = $session->snmpgettable('atIfIndex');
    if (@atifent) {
      my @atphysaddr = $session->snmpgettable('atPhysAddress');
      my @atnetaddr = $session->snmpgettable('atNetAddress');
      my($ifent, @physaddr, $netaddr);

      foreach $ifent (@atifent) {
        @physaddr = unpack('C*', shift @atphysaddr);
        $netaddr = shift @atnetaddr;
        printf("%03d.%03d.%03d.%03d", split (/\./, $netaddr));
        print("\|");
        printf("%02x", shift @physaddr);
        while(scalar @physaddr) {
          printf(":%02x", shift @physaddr);
        }
        print("\n");
      }
    }
    $session->close();
  }
}
#$ping->close();
exit 0;
